function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import Cropper from 'react-cropper';
import 'cropperjs/dist/cropper.css';
import CropImageUI from './cropImageUI';
import PropTypes from 'prop-types';
import axios from 'axios';

var AppolodoroCropImage = function (_Component) {
  _inherits(AppolodoroCropImage, _Component);

  function AppolodoroCropImage() {
    var _temp, _this, _ret;

    _classCallCheck(this, AppolodoroCropImage);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.handleScale = function (event) {
      try {
        var ratio = event.target.value > 50 && event.target.value > _this.lastZoom ? 0.1 : -0.1;
        _this.cropper.zoom(ratio, ratio);
        _this.lastZoom = event.target.value;
      } catch (error) {
        console.log(error);
      }
    }, _this.handleCrop = function () {
      var imageCropped = _this.cropper.getCroppedCanvas({
        width: _this.props.size[0],
        height: _this.props.size[1],
        minWidth: _this.props.size[0],
        minHeight: _this.props.size[1],
        maxWidth: _this.props.size[0],
        maxHeight: _this.props.size[1]
      }).toDataURL("image/jpeg", 1.0);

      _this.props.onCrop(imageCropped);
    }, _this.handleCancel = function () {
      _this.props.onCancel && _this.props.onCancel();
    }, _this.handleSetRef = function (element) {
      _this.cropper = element;
    }, _this.smartcrop = function (canvasSource, visionResponse) {
      try {
        var HORIZONTAL = 'horizontal';
        var VERTICAL = 'vertical';

        var visionData = visionResponse.data.responses;
        var vertices = visionData[0].cropHintsAnnotation.cropHints[0].boundingPoly.vertices;

        var direction = null;
        if (vertices[0].x) {
          direction = HORIZONTAL;
        }
        if (vertices[0].y) {
          direction = VERTICAL;
        }

        var cropSource = canvasSource.getContext('2d');
        var cropData = void 0;

        switch (direction) {
          case HORIZONTAL:
            cropData = cropSource.getImageData(vertices[0].x, 0, vertices[1].x - vertices[0].x, vertices[2].y);
            break;
          case VERTICAL:
            cropData = cropSource.getImageData(0, vertices[0].y, vertices[1].x, vertices[3].y - vertices[0].y);
            break;
          default:
            cropData = cropSource.getImageData(canvasSource.width / 4, canvasSource.height / 4, _this.props.size[0], _this.props.size[1]);
            break;
        }

        var canvasResult = _this.refs.canvasResult;
        canvasResult.width = cropData.width;
        canvasResult.height = cropData.height;

        var cropResult = canvasResult.getContext("2d");
        cropResult.putImageData(cropData, 0, 0);
        cropResult.width = _this.props.size[0];
        cropResult.height = _this.props.size[1];

        _this.props.onCrop(cropResult.canvas.toDataURL("image/jpeg", 1));
      } catch (error) {
        _this.props.onError(error);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  AppolodoroCropImage.prototype.setImage = function setImage(image, key) {
    var _this2 = this;

    try {
      this.props.onStart && this.props.onStart();
      var canvasSource = this.refs.canvasSource;
      var canvasSourceContext = canvasSource.getContext('2d');

      var base_image = new Image();
      base_image.src = image;
      base_image.onload = function () {
        canvasSource.width = base_image.width;
        canvasSource.height = base_image.height;
        canvasSourceContext.drawImage(base_image, 0, 0);

        _this2.requestVision(canvasSource, canvasSource.toDataURL("image/jpeg", 1), key);
      };
    } catch (error) {
      this.props.onError(error);
    }
  };

  AppolodoroCropImage.prototype.requestVision = function requestVision(canvasSource, image, key) {
    var _this3 = this;

    var requestData = {
      "requests": [{
        "image": {
          "content": '' + image.split(',')[1]
        },
        "features": [{
          "type": "CROP_HINTS"
        }],
        "imageContext": {
          "cropHintsParams": {
            "aspectRatios": [1.9]
          }
        }
      }]
    };

    axios.post('https://vision.googleapis.com/v1/images:annotate?key=' + key, requestData).then(function (response) {
      _this3.smartcrop(canvasSource, response);
    }).catch(function (error) {
      _this3.props.onError(error);
    });
  };

  AppolodoroCropImage.prototype.render = function render() {

    if (this.props.smartcrop) {
      return React.createElement(
        'div',
        null,
        React.createElement('canvas', { ref: 'canvasSource', style: { display: 'none' } }),
        React.createElement('canvas', { ref: 'canvasResult', style: { display: 'none' } })
      );
    } else {
      return React.createElement(
        'div',
        null,
        React.createElement(CropImageUI, {
          setRef: this.handleSetRef,
          scale: this.handleScale,
          crop: this.handleCrop,
          cancel: this.handleCancel,
          image: this.props.image,
          size: this.props.size
        })
      );
    }
  };

  AppolodoroCropImage.prototype.componentDidMount = function componentDidMount() {
    if (this.props.smartcrop) {
      this.setImage(this.props.image, this.props.smartcrop.key);
    }
  };

  return AppolodoroCropImage;
}(Component);

AppolodoroCropImage.propTypes = process.env.NODE_ENV !== "production" ? {
  image: PropTypes.string.isRequired,
  onStart: PropTypes.func,
  onCrop: PropTypes.func.isRequired,
  onError: PropTypes.func.isRequired,
  onCancel: PropTypes.func,
  smartcrop: PropTypes.object,
  size: PropTypes.array.isRequired
} : {};

AppolodoroCropImage.defaultProps = {};

export default AppolodoroCropImage;