'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactCropper = require('react-cropper');

var _reactCropper2 = _interopRequireDefault(_reactCropper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CropImageUI = function CropImageUI(props) {
    return _react2.default.createElement(
        'div',
        { className: 'CropImage' },
        _react2.default.createElement(_reactCropper2.default, {
            ref: props.setRef,
            src: props.image,
            dragMode: 'move',
            aspectRatio: props.size[0] / props.size[1],
            style: { width: '100%', height: window.innerWidth < 768 ? 450 / 2 : 450 },
            guides: false,
            modal: true,
            background: false,
            cropBoxResizable: false,
            cropBoxMovable: false,
            viewMode: 1,
            toggleDragModeOnDblclick: false,
            zoomOnTouch: false,
            zoomOnWheel: false
        }),
        _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement('input', { onChange: props.scale, type: 'range', min: '0', max: '100', defaultValue: '50', className: 'CropImage__slider' }),
            _react2.default.createElement(
                'button',
                { className: 'CropImage__btnCancel', onClick: props.cancel },
                'Cancel'
            ),
            _react2.default.createElement(
                'button',
                { className: 'CropImage__btnCrop', onClick: props.crop },
                'Crop'
            )
        )
    );
};

exports.default = CropImageUI;
module.exports = exports['default'];